from __future__ import annotations
from msgspec import Struct, field
from msgspec_schemaorg.models.intangible.Intangible import Intangible
from typing import TYPE_CHECKING

if TYPE_CHECKING:
    from msgspec_schemaorg.models.intangible.Class import Class
    from msgspec_schemaorg.models.intangible.Enumeration import Enumeration
    from msgspec_schemaorg.models.intangible.Property import Property
from typing import Optional, Union, Dict, List, Any


class Enumeration(Intangible):
    """Lists or enumerations—for example, a list of cuisines or music genres, etc."""
    type: str = field(default_factory=lambda: "Enumeration", name="@type")
    supersededBy: Union[List[Union['Class', 'Property', 'Enumeration']], Union['Class', 'Property', 'Enumeration'], None] = None