from __future__ import annotations
from msgspec import Struct, field
from msgspec_schemaorg.models.intangible.ListItem import ListItem
from typing import Optional, Union, Dict, List, Any


class HowToTip(ListItem):
    """An explanation in the instructions for how to achieve a result. It provides supplementary information about a technique, supply, author's preference, etc. It can explain what could be done, or what should not be done, but doesn't specify what should be done (see HowToDirection)."""
    type: str = field(default_factory=lambda: "HowToTip", name="@type")